var delay = 300, //задержка между ходами в миллисекундах
  mainPause = 10, //задержка между партиями в секундах
  board,
  game = new Chess (),
  pgnEl = $('#pgn'),
  fenEl = $('#fen'),
  mainTimeout, pauseTimeout;

var getStatus = function() {
 var status = '';
 var moveColor = 'Белые';
 if (game.turn() === game.BLACK) {
  moveColor = 'Чёрные';
 }
 if (game.in_checkmate() === true) { //Мат
  status = '' + moveColor + ' получили мат';
 }
 else if (game.in_draw() === true) { //Ничья
  status = 'Ничья, ';
  if (game.in_stalemate() === true) status +=  'пат';
  else if (game.in_threefold_repetition() === true) status +=  'повторение позиции';
  else if (game.insufficient_material() === true) status +=  'недостаточно материала';
  else status += 'правило 50 ходов';
 }
 else {
  status = '';
 }
 return (status==='' ? '' : ' {'+status+'}');
};
  
var makeRandomMove = function() {
  var possibleMoves = game.moves();
  window.clearTimeout (mainTimeout);
  if (game.game_over() === true ||
    game.in_draw() === true ||
    possibleMoves.length === 0) {
   var res = (game.in_stalemate() || game.in_draw() ? 0 : 
    (game.in_checkmate() ? (game.turn() === game.BLACK ? 1 : -1) : '0'));
    //Получить победителя из game
   var tokens = game.fen().split(' ');
   var num = tokens[5]; //Получить количество ходов из FEN
   if (res==-1) num--; //Если победили чёрные, следующий ход не был начат
   $.post("./script.php", {res: res, num: num});
   //if (res) window.setTimeout (showTimer, 1000, mainPause*3);
   pauseTimeout = window.setTimeout (showTimer, 1000, mainPause);
   return;
  }
  var randomIndex = Math.floor(Math.random() * possibleMoves.length);
  game.move(possibleMoves[randomIndex]);
  var fen = game.fen();
  board.position(fen);
  fenEl.html(fen);
  updatePGNHeaders();
  var comment = getStatus();
  pgnEl.html(game.pgn()+comment);

  mainTimeout = window.setTimeout(makeRandomMove, delay);
};

board = ChessBoard('board', 'start');
//board.moveSpeed = board.appearSpeed = board.snapbackSpeed = board.snapSpeed = board.trashSpeed = 5;

mainTimeout = window.setTimeout(makeRandomMove, delay);

function switchShow (id) { //Переключалка видимости для вывода инструкции
 var div=document.getElementById ('instructionBox');
 div.style.display = div.style.display == "none" ? "block" : "none";
 document.getElementById ('instructionLink').innerHTML = 
  div.style.display == "block" ? "СКРЫТЬ ИНСТРУКЦИЮ" : "ИНСТРУКЦИЯ";
 return false;
}

function selectElement (id) { //Выделить элемент с указанным id по клику
 var element = document.getElementById (id);
 var range = document.createRange ();
 range.selectNodeContents (element);
 var sel = window.getSelection ();
 sel.removeAllRanges ();
 sel.addRange (range);
}

function reloadMe() { //Перезагрузка
 game = new Chess ();
 board = ChessBoard('board', 'start');
 //board.moveSpeed = board.appearSpeed = board.snapbackSpeed = board.snapSpeed = board.trashSpeed = 5;
 $('#timer').html('');
 window.clearTimeout (pauseTimeout);
 mainTimeout = window.setTimeout(makeRandomMove, delay);
}

function showTimer (timer) { //Таймер
 if (timer==0) {
  reloadMe();
 }
 else {
  $('#timer').html('(ДО ПЕРЕЗАГРУЗКИ: '+(timer--)+' сек.)');
  window.clearTimeout (pauseTimeout);
  pauseTimeout = window.setTimeout(showTimer, 1000, timer);
 }
}

function updatePGNHeaders() { //Заголовки PGN
 if (game) {
  game.header('Event', 'Tournament');
  game.header('Site', 'City, Country');
  game.header('Date', dateFmt());
  game.header('Round', '1');
  game.header('White', 'Player1');
  game.header('Black', 'Player2');
  game.header('Result', getCurrentResult());
 }
}

function dateFmt() { //Дата ГГГГ.ММ.ДД
 var date = new Date();
 var day=date.getDate(); if (day<10) day='0'+day;
 var month=date.getMonth()+1; if (month<10) month='0'+month;
 var year=date.getFullYear(); 
 return year+'.'+month+'.'+day;
}

function getCurrentResult () { //Получить текущий результат из game
 return (
  game.in_stalemate() || game.in_draw() ? '1/2-1/2' : 
  (game.in_checkmate() ? (game.turn() === game.BLACK ? '1-0' : '0-1') : '*')
 );
}